/*
 * (c) 2022, SWD Embedded Systems Limited, http://www.kpda.ru
 */


#define DEFN

#include "externs.h"
#include <stdarg.h>


exar_dev_t  exar_dev;
int         driver_verbosity_level;


int devc_slogf( int verbosity_level, const char *fmt, ... )
{
    int         status   = 0;
    va_list     arg;
    const char  *infostr = "INFO";
    int         severity = _SLOG_INFO;

    switch ( verbosity_level )
    {
        case 0:
            infostr  = "ERROR";
            severity = _SLOG_ERROR;
            break;
        case 1:
            infostr  = "WARNING";
            severity = _SLOG_WARNING;
            break;
        case 3:
            infostr  = "DEBUG";
            severity = _SLOG_DEBUG1;
            break;
        default:
            infostr  = "INFO";
            severity = _SLOG_INFO;
            break;
    }

    if ( driver_verbosity_level < verbosity_level )
        return (0);

    va_start( arg, fmt );
    status += fprintf( stderr, "\t %s : ", infostr );
    status  = vfprintf( stderr, fmt, arg );
    vslogf( DEVC_EXAR_SLOG_OPCODE, severity, fmt, arg );
    status += fprintf( stderr, "\n" );
    va_end( arg );

    return status;
}
